/*
 * joey-gen and its relative products are published under the terms
 * of the Apache Software License.
 * 
 * Created on 2004/11/25 17:58:58
 */
package org.asyrinx.joey.gen.core;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.apache.velocity.context.Context;
import org.asyrinx.joey.gen.velocity.VelocityUtils;

/**
 * @author takeshi
 */
public class VelocityHelper {

    /**
     *  
     */
    public VelocityHelper(Context context) {
        super();
        this.context = context;
    }

    private final Context context;

    public Object newInstance(String className) {
        try {
            return Class.forName(className).newInstance();
        } catch (Exception e) {
            return null;
        }
    }

    public Set toSet(Collection collection) {
        final Set result = new HashSet();
        for (Iterator i = collection.iterator(); i.hasNext();)
            result.add(i.next());
        return result;
    }

    public Object put(String key, Object value) {
        return context.put(key, value);
    }

    public String debugContext() {
        final StringBuffer result = new StringBuffer();
        result.append("hashCode=").append(this.context.hashCode()).append("\n");
        final Map map = VelocityUtils.toMap(this.context);
        for (Iterator i = map.entrySet().iterator(); i.hasNext();) {
            final Map.Entry entry = (Map.Entry) i.next();
            result.append(entry.getKey()).append("=").append(entry.getValue()).append("\n");
        }
        return result.toString();
    }

}