/*
 * joey-gen and its relative products are published under the terms
 * of the Apache Software License.
 * 
 * Created on 2004/12/27 12:05:27
 */
package org.asyrinx.joey.gen.model.rdb;

import org.asyrinx.joey.gen.model.Element;
import org.asyrinx.joey.gen.model.ElementSet;
import org.asyrinx.joey.gen.model.command.ValidationError;
import org.asyrinx.joey.gen.model.pattern.Pattern;
import org.asyrinx.joey.gen.model.pattern.PatternRepository;

/**
 * @author takeshi
 */
public class TablePattern extends ElementSet {

    /**
     * @param parent
     */
    public TablePattern() {
        super(null, null, null);
    }

    /**
     * @param parent
     * @param name
     * @param label
     */
    public TablePattern(Element parent, String name, String label) {
        super(parent, name, label);
    }

    /**
     * @param name
     */
    public TablePattern(String name) {
        super(name);
    }

    public boolean isEntity() {
        return true;
    }

    public void add(TablePatternParam param) {
        super.add(param);
    }

    public boolean contains(TablePatternParam param) {
        return super.contains(param);
    }

    public TablePatternParam getParam(int idx) {
        return (TablePatternParam) super.getElement(idx);
    }

    public TablePatternParam getParam(String name) {
        return (TablePatternParam) super.getElement(name);
    }

    public TablePatternParam removeParam(String name) {
        return (TablePatternParam) super.removeElement(name);
    }

    public Table getParent() {
        return (Table) super.getParentElement();
    }

    public String getParameter(String paramName) {
        final TablePatternParam param = this.getParam(paramName);
        return (param == null) ? null : param.getValue();
    }

    public Pattern toPattern() {
        final Pattern pattern = PatternRepository.getInstance().get(this.getName());
        if (pattern == null)
            throw new ValidationError("no pattern implementation", this);
        return pattern;
    }

    public boolean isTarget(String templatePath) {
        return toPattern().isTarget(templatePath);
    }

}